Imports Telerik.Web.UI
Imports System.Collections.Generic
Imports System.Web.Script.Serialization

Partial Class SaveLoadState
    Inherits System.Web.UI.Page
    Private Property CurrentDockStates() As List(Of DockState)
        Get
            Dim _currentDockStates As List(Of DockState) = DirectCast(Session("CurrentDockStatesDynamicDocks"), List(Of DockState))
            If [Object].Equals(_currentDockStates, Nothing) Then
                _currentDockStates = New List(Of DockState)()
                Session("CurrentDockStatesDynamicDocks") = _currentDockStates
            End If
            Return _currentDockStates
        End Get
        Set(ByVal value As List(Of DockState))
            Session("CurrentDockStatesDynamicDocks") = value
        End Set
    End Property

    Protected Overloads Overrides Sub RaisePostBackEvent(ByVal sourceControl As IPostBackEventHandler, ByVal eventArgument As String)
        MyBase.RaisePostBackEvent(sourceControl, eventArgument)

        'As docks positions are authomatically saved when a postback occurs 
        'if you want to save the current positions only at save button click 
        'you need to reset to the old positions if save button has not been clicked 
        If TypeOf sourceControl Is System.Web.UI.WebControls.Button Then
            Dim button As Button = DirectCast(sourceControl, Button)
            If button.ID = "SaveButton" Then
                Return
            End If
        End If
        SetPositions()
    End Sub

    Protected Sub Page_Init(ByVal sender As Object, ByVal e As EventArgs)
        BuildThePage()
    End Sub

    Private Sub BuildThePage()
        For i As Integer = 1 To 3
            Dim rd As New RadDock()
            rd.ID = "DockPhoto_" + i.ToString()
            rd.Title = "dock" + i.ToString()
            Dim img As New Image()
            img.CssClass = "thumbnail"
            img.ID = "thumbnail"
            img.ImageUrl = "~/Imgs/test" + i.ToString() + ".jpg"
            img.Width = Unit.Pixel(100)
            img.Height = Unit.Pixel(80)
            img.ToolTip = "Photo"
            rd.ContentContainer.Controls.Add(img)
            rd.Width = Unit.Pixel(120)
            rd.Height = Unit.Pixel(120)
            rd.EnableViewState = False
            RadDockZoneHorizontal1.Controls.Add(rd)
        Next
    End Sub

    Protected Sub RadDockLayout1_LoadDockLayout(ByVal sender As Object, ByVal e As DockLayoutEventArgs)
        'Populate the event args with the state information. The RadDockLayout control 
        ' will automatically move the docks according that information. 
        For Each state As DockState In CurrentDockStates
            e.Positions(state.UniqueName) = state.DockZoneID
            e.Indices(state.UniqueName) = state.Index
        Next
    End Sub

    Protected Sub RadDockLayout1_SaveDockLayout(ByVal sender As Object, ByVal e As DockLayoutEventArgs)
        'If the page is loaded for the first time 
        'initialize the dock states 
        If Not Page.IsPostBack Then
            CurrentDockStates = RadDockLayout1.GetRegisteredDocksState()
        End If
    End Sub

    Protected Sub SaveButton_Click(ByVal sender As Object, ByVal e As EventArgs)
        'Saves the current positions only if save state button is clicked 
        CurrentDockStates = RadDockLayout1.GetRegisteredDocksState()
        SetPositions()
    End Sub

    Private Sub SetPositions()
        Dim positions As New Dictionary(Of String, String)()
        Dim indices As New Dictionary(Of String, Integer)()
        For Each state As DockState In CurrentDockStates
            positions(state.UniqueName) = state.DockZoneID
            indices(state.UniqueName) = state.Index
        Next
        RadDockLayout1.SetRegisteredDockParents(positions, indices)
    End Sub
End Class
